Index: lib/spatial/mapbuilder/examples/projDemo/CursorTrack.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/projDemo/CursorTrack.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/projDemo/CursorTrack.xsl	(revision 4307)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+
+<!--
+Description: Output a form for display of the cursor coordinates
+Author:      Mike Adair
+Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: CursorTrack.xsl 2576 2007-02-19 09:14:01Z gjvoosten $
+-->
+
+  <xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/>
+
+  <!-- The common params set for all widgets -->
+  <xsl:param name="lang">en</xsl:param>
+  
+  <!-- text value params -->
+  <xsl:param name="longitude">lon:</xsl:param>
+  <xsl:param name="latitude">lat:</xsl:param>
+  <xsl:param name="xcoord">x:</xsl:param>
+  <xsl:param name="ycoord">y:</xsl:param>
+  <xsl:param name="pixel">pixel:</xsl:param>
+  <xsl:param name="line">line:</xsl:param>
+  <xsl:param name="showXY">false</xsl:param>
+  <xsl:param name="showDMS">false</xsl:param>
+  <xsl:param name="showDM">false</xsl:param>
+  <xsl:param name="showMGRS">false</xsl:param>
+  <xsl:param name="showPx">false</xsl:param>
+  <xsl:param name="showLatLong">true</xsl:param>
+  
+  <!-- The name of the form for coordinate output -->
+  <xsl:param name="formName"/>
+
+  <!-- Main html -->
+  <xsl:template match="/">
+    <div>
+    <form name="{$formName}" id="{$formName}">
+      <ul>
+      
+        <xsl:if test="$showPx='true'">
+          <li>
+            <span class="cursorTrackLeft">
+              <xsl:value-of select="$pixel"/> <input name="px" type="text" size="8" readonly="readonly"/>
+            </span>
+            <span class="cursorTrackRight">
+              <xsl:value-of select="$line"/> <input name="py" type="text" size="8" readonly="readonly"/>
+            </span>
+          </li>
+        </xsl:if>
+        
+        <xsl:if test="$showXY='true'">
+          <li>
+            <span class="cursorTrackLeft">
+              <xsl:value-of select="$xcoord"/> <input name="x" type="text" size="8" readonly="readonly"/>
+            </span>
+            <span class="cursorTrackRight">
+              <xsl:value-of select="$ycoord"/> <input name="y" type="text" size="8" readonly="readonly"/>
+            </span>
+          </li>
+        </xsl:if>
+        
+        <xsl:if test="$showDMS='true'">
+          <li>
+            <span class="cursorTrackLeft">
+              <xsl:value-of select="$longitude"/> 
+              <input name="longdeg" type="text" size="3" readonly="readonly"/>&#176;
+              <input name="longmin" type="text" size="2" readonly="readonly"/>&apos;
+              <input name="longsec" type="text" size="2" readonly="readonly"/>&quot;
+              <input name="longH" type="text" size="1" readonly="readonly"/>&#8195;
+            </span>
+            <span class="cursorTrackRight">
+              <xsl:value-of select="$latitude"/> 
+              <input name="latdeg" type="text" size="2" readonly="readonly"/>&#176;
+              <input name="latmin" type="text" size="2" readonly="readonly"/>&apos;
+              <input name="latsec" type="text" size="2" readonly="readonly"/>&quot;
+              <input name="latH" type="text" size="1" readonly="readonly"/>
+            </span>
+          </li>
+        </xsl:if>
+        
+        <xsl:if test="$showDM='true'">
+          <li>
+            <span class="cursorTrackLeft">
+              <xsl:value-of select="$longitude"/> 
+              <input name="longDMdeg" type="text" size="3" readonly="readonly"/>&#176;
+              <input name="longDMmin" type="text" size="6" readonly="readonly"/>&apos;
+              <input name="longDMH" type="text" size="1" readonly="readonly"/>&#8195;
+            </span>
+            <span class="cursorTrackRight">
+              <xsl:value-of select="$latitude"/> 
+              <input name="latDMdeg" type="text" size="2" readonly="readonly"/>&#176;
+              <input name="latDMmin" type="text" size="6" readonly="readonly"/>&apos;
+              <input name="latDMH" type="text" size="1" readonly="readonly"/>
+            </span>
+          </li>
+        </xsl:if>
+
+        <xsl:if test="$showLatLong='true'">
+          <li>
+            <span class="cursorTrackLeft">
+              <xsl:value-of select="$longitude"/> <input name="longitude" type="text" size="8" readonly="readonly"/>
+            </span>
+            <span class="cursorTrackRight">
+              <xsl:value-of select="$latitude"/> <input name="latitude" type="text" size="8" readonly="readonly"/>
+            </span>
+          </li>
+        </xsl:if>
+ 
+        <xsl:if test="$showMGRS='true'">
+          <li>
+          MGRS: <input name="mgrs" type="text" size="14" readonly="readonly"/>
+          </li>
+        </xsl:if>
+     
+      </ul>
+      </form>
+    </div>
+  </xsl:template>
+
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/GeoBliki/wfs_GetFeature.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/GeoBliki/wfs_GetFeature.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/GeoBliki/wfs_GetFeature.xsl	(revision 4307)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<!--
+Description: transforms a WFS FeatureType node to a GetFeatureType request
+Author:      adair
+Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
+$Id: wfs_GetFeature.xsl 2546 2007-01-23 12:07:39Z gjvoosten $
+$Name$
+-->
+
+<xsl:stylesheet version="1.0" 
+    xmlns:wfs="http://www.opengis.net/wfs"
+    xmlns:sld="http://www.opengis.net/sld"
+    xmlns:wmc="http://www.opengis.net/context" 
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+    xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" 
+		xmlns:ogc="http://www.opengis.net/ogc"
+		xmlns:gml="http://www.opengis.net/gml"
+    xmlns:xlink="http://www.w3.org/1999/xlink">
+
+  <xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="no"/>
+  <xsl:preserve-space elements="gml:coordinates"/>
+  <xsl:param name="cs" select="','"/>
+  <xsl:param name="ts" select="' '"/>
+  <xsl:param name="bBoxMinX"/>
+  <xsl:param name="bBoxMinY"/>
+  <xsl:param name="bBoxMaxX"/>
+  <xsl:param name="bBoxMaxY"/>
+  <xsl:param name="srs"/>
+  <xsl:param name="version"/>
+  <xsl:param name="httpMethod" />
+  <xsl:param name="filter"/>
+  <xsl:param name="maxFeatures">100</xsl:param>
+  <xsl:param name="geometry">location</xsl:param>
+  <xsl:param name="resourceName" />
+  <xsl:param name="featureSrs" />
+  <xsl:param name="fromDateField" />
+  <xsl:param name="toDateField" />
+ 
+  <!-- template rule matching source root element -->
+
+  <xsl:template match="/">
+  
+    <wmc:FeatureType hidden="0" id="B58B8C7B-6592-4D67-9CD5-5D43CB46BF83">
+	  	<wmc:Server service="OGC:WFS" version="1.0.0" title="EO1 GeoBliki">
+        <wmc:OnlineResource method="post" xlink:type="simple" xlink:href="http://test.geobliki.com/wfs"/>
+      </wmc:Server>
+      <wmc:Name>EO1 Query</wmc:Name>
+      <wmc:Title>EO1 Query</wmc:Title>
+
+      <wfs:GetFeature version="1.0.0" service="WFS" maxFeatures="{$maxFeatures}">
+        <wfs:Query typeName="{$resourceName}">
+         <ogc:Filter>
+            <ogc:And>
+              <xsl:if test="$bBoxMinX">
+                <ogc:BBOX>
+                  <ogc:PropertyName><xsl:value-of select="$geometry"/></ogc:PropertyName>
+                  <gml:Box srsName="{$srs}"><gml:coordinates>
+            				<xsl:value-of select="$bBoxMinX"/><xsl:value-of select="$cs"/>
+            				<xsl:value-of select="$bBoxMinY"/><xsl:value-of select="$ts"/>
+            				<xsl:value-of select="$bBoxMaxX"/><xsl:value-of select="$cs"/>
+            				<xsl:value-of select="$bBoxMaxY"/>
+                  </gml:coordinates></gml:Box>
+                </ogc:BBOX>
+              </xsl:if> 
+              
+              <xsl:if test="$fromDateField">
+               <ogc:PropertyIsBetween>
+   		  				 <ogc:PropertyName>created_at</ogc:PropertyName>
+			  					 <ogc:LowerBoundary>
+    								 <DateTime><xsl:value-of select="$fromDateField"/></DateTime>
+  		  					 </ogc:LowerBoundary>
+			  					 <ogc:UpperBoundary>
+    								 <DateTime><xsl:value-of select="$toDateField"/></DateTime>
+  		  					</ogc:UpperBoundary>
+  						 </ogc:PropertyIsBetween>  
+              </xsl:if>
+              
+            </ogc:And>
+          </ogc:Filter>
+        </wfs:Query>
+      </wfs:GetFeature>
+      <wmc:StyleList>
+			  <wmc:Style>
+				  <wmc:Name>Highlite</wmc:Name>
+				  <sld:PointSymbolizer>
+					  <sld:Graphic>
+						  <sld:Mark>
+							  <sld:WellKnownName>circle</sld:WellKnownName>
+							  <sld:Fill>
+								  <sld:CssParameter name="fill">#ff0000</sld:CssParameter>
+							  </sld:Fill>
+						  </sld:Mark>
+						  <sld:Size>4.0</sld:Size>
+					  </sld:Graphic>
+					  <sld:Stroke>
+						  <sld:CssParameter name="stroke">#ffff00</sld:CssParameter>
+						  <sld:CssParameter name="stroke-width">1</sld:CssParameter>
+					  </sld:Stroke>
+				  </sld:PointSymbolizer>
+			  </wmc:Style>
+			  <wmc:Style>
+				  <wmc:Name>Normal</wmc:Name>
+				  <sld:PointSymbolizer>
+					  <sld:Graphic>
+						  <sld:Mark>
+							  <sld:WellKnownName>circle</sld:WellKnownName>
+							  <sld:Fill>
+								  <sld:CssParameter name="fill">#ff0000</sld:CssParameter>
+							  </sld:Fill>
+						  </sld:Mark>
+						  <sld:Size>4.0</sld:Size>
+					  </sld:Graphic>
+				  </sld:PointSymbolizer>
+			  </wmc:Style>
+		  </wmc:StyleList>
+    </wmc:FeatureType>
+  </xsl:template>
+</xsl:stylesheet>
+
Index: lib/spatial/mapbuilder/examples/i18n/LanguageUtils.js
===================================================================
--- lib/spatial/mapbuilder/examples/i18n/LanguageUtils.js	(nonexistent)
+++ lib/spatial/mapbuilder/examples/i18n/LanguageUtils.js	(revision 4307)
@@ -0,0 +1,69 @@
+/*
+License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: LanguageUtils.js 3874 2008-02-27 11:03:22Z gjvoosten $
+*/
+
+// Supported languages
+var supportedLanguages = new Object();
+{
+  supportedLanguages["en"] = "English";
+  supportedLanguages["nl"] = "Nederlands";
+  supportedLanguages["fr"] = "Fran\u00E7ais";
+  supportedLanguages["it"] = "Italiano";
+  supportedLanguages["de"] = "Deutsch";
+  supportedLanguages["es"] = "Espa\u00F1ol";
+  // Also add as an example an unsupported language to show the fallback
+  supportedLanguages["nonesuch"] = "unsupported language";
+}
+var language = "en"; // Default to English
+
+/**
+ * Set the language for a page by getting it from the page parameters
+ */
+function setLanguage()
+{
+  var parms = getParameters();
+  if (parms["language"] && supportedLanguages[parms["language"]]) {
+    language = parms["language"];
+  }
+}
+
+/**
+ * Write out the HTML with hrefs for changing the language of the page
+ * @param flagsDirUrl the (relative) url of the directory containing the flag images
+ */
+function writeOutLanguages(flagsDirUrl)
+{
+  for (var i in supportedLanguages) {
+    document.write("&nbsp;");
+    if (language != i) {
+      document.write('<a href="?language=' + i + '">');
+    }
+    document.write('<img src="' + flagsDirUrl + '/' + i +
+      '.png" title="' + supportedLanguages[i] + '"/>');
+    if (language != i) {
+      document.write('</a>');
+    }
+  }
+}
+
+/**
+ * Get the page parameters
+ * @return an object with the parameter names as fields and the parameter values
+ *         as the corresponding values
+ */
+function getParameters()
+{
+  var args = new Object();
+  var query = location.search.substring(1);
+  var pairs = query.split("&");
+  for (var i in pairs) {
+    var pos = pairs[i].indexOf('=');
+    if (pos == -1) continue;
+    var argname = pairs[i].substring(0, pos);
+    var value = pairs[i].substring(pos + 1);
+    args[argname] = unescape(value.replace(/\+/g, " "));
+  }
+  return args;
+}
Index: lib/spatial/mapbuilder/examples/GeoBliki/datapopup.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/GeoBliki/datapopup.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/GeoBliki/datapopup.xsl	(revision 4307)
@@ -0,0 +1,81 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:gml="http://www.opengis.net/gml" xmlns:wfs="http://www.opengis.net/wfs" xmlns:eo1="http://eo1.gsfc.nasa.gov/" version="1.0">
+
+  <!--
+    Description: Convert a GeoBliki WFS response into a OL popup text.
+    Author:      Andreas Hocevar
+    $Id: datapopup.xsl 3907 2008-03-06 10:27:06Z steven $
+  -->
+
+  <xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/>
+
+  <!-- Common params for all widgets -->
+  <xsl:param name="modelId" />
+  <xsl:param name="widgetId" />
+
+  <!-- params for this widget -->
+  <xsl:param name="fid" />
+
+  <!-- Main html - It matches only non-empty results -->
+  <xsl:template match="/">
+    <div class="PopupContainer">
+      <div class="PopupHeader">Info</div>
+      <div class="PopupContent">
+        <xsl:apply-templates />
+      </div>
+    </div>
+  </xsl:template>
+
+  <!-- featureInfo -->
+  <xsl:template match="wfs:FeatureCollection/gml:featureMember/eo1:ali|wfs:FeatureCollection/gml:featureMember/eo1:hyperion">
+    <xsl:if test="@fid=$fid">
+      <table cellspacing="0" border="0">
+        <tr>
+          <td>
+            <xsl:element name="img">
+              <xsl:attribute name="height">200</xsl:attribute>
+              <xsl:attribute name="src">
+                <xsl:value-of select="eo1:lowres_href" />
+              </xsl:attribute>
+            </xsl:element>
+          </td>
+          <td>
+            <b>Id:</b>
+            <xsl:value-of select="eo1:id" />
+            <br />
+            <b>Name:</b>
+            <xsl:value-of select="eo1:name" />
+            <br />
+            <b>Scene:</b>
+            <xsl:value-of select="eo1:scene" />
+            <br />
+            <b>Rights:</b>
+            <xsl:value-of select="eo1:rights" />
+            <br />
+            <b>Goal Id:</b>
+            <xsl:value-of select="eo1:goal_id" />
+            <br />
+            <b>Lat:</b>
+            <xsl:value-of select="eo1:latitude" />
+            <br />
+            <b>Lon:</b>
+            <xsl:value-of select="eo1:longitude" />
+            <br />
+            <b>Link:</b>
+            <xsl:element name="a">
+              <xsl:attribute name="href">
+                <xsl:value-of select="eo1:article_href" />
+              </xsl:attribute>
+              here
+            </xsl:element>
+            <br />
+          </td>
+        </tr>
+      </table>
+    </xsl:if>
+  </xsl:template>
+
+  <!-- Remove documentation, text, comments -->
+  <xsl:template match="comment()|text()|processing-instruction()"></xsl:template>
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/GeoBliki/geobliki2wfs.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/GeoBliki/geobliki2wfs.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/GeoBliki/geobliki2wfs.xsl	(revision 4307)
@@ -0,0 +1,27 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:gml="http://www.opengis.net/gml" xmlns:eo1="http://eo1.gsfc.nasa.gov/" xmlns:wfs="http://www.opengis.net/wfs"> 
+<!--
+Description: A stylesheet to convert strange geobliki wfs to standards-compliant wfs.
+Author:      Andreas Hocevar andreas.hocevarATgmail.com
+Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: geobliki2wfs.xsl 2957 2007-07-09 12:21:10Z steven $
+-->
+  <xsl:template match="gml:featureMember">
+    <wfs:FeatureCollection>
+      <xsl:for-each select="eo1:ali">
+        <xsl:call-template name="featureMember"/>
+      </xsl:for-each>
+      <xsl:for-each select="eo1:hyperion">
+        <xsl:call-template name="featureMember"/>
+      </xsl:for-each>
+    </wfs:FeatureCollection>
+  </xsl:template>
+
+  <xsl:template name="featureMember">
+    <gml:featureMember>
+      <xsl:copy-of select="current()"/>
+    </gml:featureMember>
+  </xsl:template>
+</xsl:stylesheet>
+
Index: lib/spatial/mapbuilder/examples/contextEditor/OWSCatResultList.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/contextEditor/OWSCatResultList.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/contextEditor/OWSCatResultList.xsl	(revision 4307)
@@ -0,0 +1,78 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<!--
+Description: presents the list of FeatureTypes from a WFS capabilities doc.
+            Links provided to filter and load the selected FeatureType.
+Author:      adair
+Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
+
+$Id: OWSCatResultList.xsl 3907 2008-03-06 10:27:06Z steven $
+$Name:  $
+-->
+
+<xsl:stylesheet version="1.0" 
+    xmlns:wfs="http://www.opengis.net/wfs"
+    xmlns:owscat="http://www.ec.gc.ca/owscat"
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+		xmlns:ogc="http://www.opengis.net/ogc"
+		xmlns:gml="http://www.opengis.net/gml"
+    xmlns:xlink="http://www.w3.org/1999/xlink">
+
+  <xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/>
+
+  <!-- The coordinates of the DHTML Layer on the HTML page -->
+  <xsl:param name="modelId"/>
+  <xsl:param name="widgetId"/>
+  <xsl:param name="skinDir"/>
+
+  <xsl:param name="tooltip">click to add the layer to the map</xsl:param>
+  
+  <!-- template rule matching source root element -->
+  <xsl:template match="/wfs:FeatureCollection">
+    <table>
+      <tr>
+        <th>
+          Search results:
+        </th>
+      </tr>
+      <xsl:apply-templates select="gml:featureMember/owscat:service_resources"/>
+    </table>
+  </xsl:template>
+
+  <!-- template rule matching source root element -->
+  <xsl:template match="owscat:service_resources">
+    <xsl:variable name="rowClass">altRow_<xsl:value-of select="position() mod 2"/></xsl:variable>
+    <xsl:variable name="abstract" select="owscat:abstract"/>
+    <xsl:variable name="name" select="owscat:name"/>
+    <tr class="{$rowClass}">
+      <td>
+        <h4>
+        <a href="javascript:config.objects.addLayer.addLayerFromCat('{$name}')" class="mbButton">
+          <img src="{$skinDir}/images/LayerAddDisable.png" title="{$tooltip}" border="0"/>
+        </a>
+        <xsl:value-of select="owscat:title"/></h4>
+        <xsl:value-of select="concat(substring($abstract, 0, 200),'...')"/>
+        <span class="dataSource">provided by: <xsl:value-of select="owscat:organization"/></span>
+      </td>
+    </tr>
+  </xsl:template>
+  
+  <!-- template rule matching Service Exception in the response -->
+  <xsl:template match="/ogc:ServiceExceptionReport">
+    <table>
+      <tr>
+        <th align="left">
+          Error executing your request:
+        </th>
+      </tr>
+      <tr>
+        <td>
+          <xsl:value-of select="ogc:ServiceException"/>
+        </td>
+      </tr>
+    </table>
+  </xsl:template>
+
+  <xsl:template match="text()|@*"/>
+
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/contextEditor/OWSCatSearchForm.js
===================================================================
--- lib/spatial/mapbuilder/examples/contextEditor/OWSCatSearchForm.js	(nonexistent)
+++ lib/spatial/mapbuilder/examples/contextEditor/OWSCatSearchForm.js	(revision 4307)
@@ -0,0 +1,182 @@
+/*
+Author:       Mike Adair mike.adairATccrs.nrcan.gc.ca
+License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: OWSCatSearchForm.js 2097 2006-04-26 17:33:19Z madair $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+
+/**
+ * Widget to display a form for input of parameters to generate a web service 
+ * request.  This JS object handles the form submit via HTTP Get by appending 
+ * a query string to the form's action URL.  The query string is created from
+ * all input elements and their values.
+ * The target model is then loaded from the URL created.
+ * A stylehseet must be specified as a property in config for this widget.  
+ * See widget/NtsForm.xsl for an example. 
+ *
+ * @constructor
+ * @base WidgetBase
+ * @param widgetNode This widget's object node from the configuration document.
+ * @param model The model that this widget is a view of.
+ */
+
+function OWSCatSearchForm(widgetNode, model) {
+  WidgetBaseXSL.apply(this, new Array(widgetNode, model));
+
+  //get bbox inforamtion from a map model
+  var mapModel = widgetNode.selectSingleNode("mb:mapModel");
+  if ( mapModel ) {
+    this.mapModel = mapModel.firstChild.nodeValue;
+  } else {
+    this.mapModel = model.id;
+  }
+
+
+  /**
+   * Refreshes the form onblur handlers when this widget is painted.
+   * @param objRef Pointer to this CurorTrack object.
+   */
+  this.postPaint = function(objRef) {
+    config.objects[objRef.mapModel].addListener('aoi', this.displayAoiCoords, this);
+
+    objRef.searchForm = document.getElementById(objRef.formName);
+    objRef.searchForm.parentWidget = objRef;
+
+    objRef.searchForm.westCoord.onblur = objRef.setAoi;
+    objRef.searchForm.northCoord.onblur = objRef.setAoi;
+    objRef.searchForm.eastCoord.onblur = objRef.setAoi;
+    objRef.searchForm.southCoord.onblur = objRef.setAoi;
+    objRef.searchForm.westCoord.model = objRef.model;
+    objRef.searchForm.northCoord.model = objRef.model;
+    objRef.searchForm.eastCoord.model = objRef.model;
+    objRef.searchForm.southCoord.model = objRef.model;
+
+    objRef.searchForm.onkeypress = objRef.handleKeyPress;
+    objRef.searchForm.onsubmit = objRef.submitForm;
+    //objRef.searchForm.mapsheet.onblur = objRef.setMapsheet;
+  }
+
+  /**
+   * Output the AOI coordinates to the associated form input elements.  This
+   * method is registered as an AOI listener on the context doc.
+   * @param objRef Pointer to this searchForm object.
+   */
+  this.displayAoiCoords = function(objRef) {
+    //objRef.searchForm = document.getElementById(objRef.formName);
+    var aoi = config.objects[objRef.mapModel].getParam("aoi");
+    objRef.searchForm.westCoord.value = aoi[0][0];
+    objRef.searchForm.northCoord.value = aoi[0][1];
+    objRef.searchForm.eastCoord.value = aoi[1][0];
+    objRef.searchForm.southCoord.value = aoi[1][1];
+  }
+
+  /**
+   * Handles user input from the form element.  This is an onblur handler for 
+   * the input elements.
+   */
+  this.setAoi = function() {
+    var aoi = config.objects[objRef.mapModel].getParam("aoi");
+    if (aoi) {
+      var ul = aoi[0];
+      var lr = aoi[1];
+      switch(this.name) {
+        case 'westCoord':
+          ul[0] = this.value;
+          break;
+        case 'northCoord':
+          ul[1] = this.value;
+          break;
+        case 'eastCoord':
+          lr[0] = this.value;
+          break;
+        case 'southCoord':
+          lr[1] = this.value;
+          break;
+      }
+      config.objects[objRef.mapModel].setParam("aoi",new Array(ul,lr) );
+    }
+  }
+
+/**
+ * Change the AOI coordinates from select box choice of prefined locations
+ * @param bbox the bbox value of the location keyword chosen
+ */
+  this.setLocation = function(bbox) {
+    var bboxArray = new Array();
+    bboxArray     = bbox.split(",");
+    var ul = new Array(parseFloat(bboxArray[0]),parseFloat(bboxArray[2]));
+    var lr = new Array(parseFloat(bboxArray[1]),parseFloat(bboxArray[3]));
+    config.objects[this.mapModel].setParam("aoi",new Array(ul,lr));
+
+    //convert this.model XY to latlong
+    //convert latlong to targetmodel XY
+    //extent.setAoi takes XY as input
+    //this.targetModel.setParam("aoi", new Array(ul,lr));
+    //this.targetModel.setParam("mouseup",this);
+  }
+
+
+  /**
+   * Handles submission of the form (via javascript in an <a> tag)
+   */
+  this.submitForm = function() {
+    var thisWidget = this.parentWidget;
+    thisWidget.createFilter(thisWidget);
+    thisWidget.targetModel.setParam("wfs_GetFeature","service_resources");
+    return false;
+  }
+
+  /**
+   * creates the filter expression
+   */
+  this.createFilter = function(objRef) {
+    objRef.searchForm = document.getElementById(objRef.formName);
+
+    var aoi = config.objects[objRef.mapModel].getParam("aoi");
+    var bboxStr = "";
+    if (aoi) {
+      bboxStr = aoi[0][0]+","+aoi[1][1]+" "+aoi[1][0]+","+aoi[0][1];
+    } else {
+      var bbox = config.objects[objRef.mapModel].getBoundingBox();
+      bboxStr = bbox[0]+","+bbox[1]+" "+bbox[2]+","+bbox[3];
+    }
+    objRef.model.setXpathValue(objRef.model,"/Filter/And/BBOX/Box/coordinates",bboxStr,false);
+    var keywords = "*"+objRef.searchForm.keywords.value+"*";
+    objRef.model.setXpathValue(objRef.model,"/Filter/And/Or/Or/PropertyIsLike[PropertyName='title']/Literal",keywords,false);
+    objRef.model.setXpathValue(objRef.model,"/Filter/And/Or/Or/PropertyIsLike[PropertyName='abstract']/Literal",keywords,false);
+    objRef.model.setXpathValue(objRef.model,"/Filter/And/Or/PropertyIsLike[PropertyName='keywords']/Literal",keywords,false);
+
+    objRef.model.setXpathValue(objRef.model,"/Filter/And/PropertyIsEqualTo[PropertyName='service_type']/Literal",objRef.searchForm.serviceType.value,false);
+  }
+
+
+  /**
+   * handles keypress events to filter out everything except "enter".  
+   * Pressing the "enter" key will trigger a form submit
+   * @param event  the event object passed in for Mozilla; IE uses window.event
+   */
+  this.handleKeyPress = function(event) {
+    var keycode;
+    var target;
+    if (event){
+      //Mozilla
+      keycode=event.which;
+      target=event.currentTarget;
+    }else{
+      //IE
+      keycode=window.event.keyCode;
+      target=window.event.srcElement.form;
+    }
+
+    if (keycode == 13) {    //enter key
+      return true;
+    }
+  }
+
+  //set some properties for the form output
+  this.formName = "WebServiceForm_" + mbIds.getId();
+  this.stylesheet.setParameter("formName", this.formName);
+}
